## kadu 1.2

=== CMakeLists.txt ===
project (Kadu)

cmake_minimum_required (VERSION 2.8.10)

# Options (some of them)

option (ENABLE_DEVELOPER_BUILD "Turn on some features helpful during development process (has nothing to do with debugging symbols)" OFF)
option (INSTALL_SDK "Install SDK (API headers, CMake modules, MSVC program libraries)" ON)
option (BUILD_TESTING "Build the test suite." "${ENABLE_DEVELOPER_BUILD}")

# Global CMake variables

list (INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")

set (CMAKE_INCLUDE_CURRENT_DIR ON)
set (CMAKE_AUTOMOC ON)

if (NOT DEFINED CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
	if (ENABLE_DEVELOPER_BUILD)
		set (default Debug)
	else ()
		set (default RelWithDebInfo)
	endif ()

	set (CMAKE_BUILD_TYPE "${default}" CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif ()

# C++11 support, warnings and other flags

set (DEFINITIONS QT_USE_QSTRINGBUILDER QT_NO_CAST_TO_ASCII)
if (BUILD_TESTING)
	list (APPEND DEFINITIONS KADU_EXPORT_TESTS)
endif ()
set (DEFINITIONS_DEBUG DEBUG_ENABLED DEBUG_OUTPUT_ENABLED)

if (MSVC)
	set (COMMON_COMPILE_FLAGS "/MP /Zc:wchar_t-")
	list (APPEND DEFINITIONS _CRT_SECURE_NO_WARNINGS=1)
else ()
	set (COMMON_COMPILE_FLAGS "-Wall -Wextra -Wundef -Wunused -Wuninitialized -Wcast-align -Wpointer-arith -fno-common")
	set (C_FLAGS "-Wwrite-strings")
	set (CXX_FLAGS "-Woverloaded-virtual -Wnon-virtual-dtor -std=c++0x")
	set (CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}")

	if (NOT WIN32)
		set (COMMON_COMPILE_FLAGS "${COMMON_COMPILE_FLAGS} -fvisibility=hidden")
		set (CXX_FLAGS "${CXX_FLAGS} -fvisibility-inlines-hidden")
	endif ()

	# Qt 4.8.5 cannot detect Clang's C++11 features, it depends on
	# detected GCC version, anc Clang mimics GCC 4.2.1. Let's mimic
	# GCC 4.8.1.
	if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
		set (COMMON_COMPILE_FLAGS "${COMMON_COMPILE_FLAGS} -U__GNUC_MINOR__ -D__GNUC_MINOR__=8")
	endif ()

	if (ENABLE_DEVELOPER_BUILD)
		# -pipe can speed up the build
		# -ftrapv generates trap on signed integer overflow, which is undefined by C/C++
		# -fno-omit-frame-pointer gives potentially better stack traces at the cost of negligible performance drop
		set (COMMON_COMPILE_FLAGS "${COMMON_COMPILE_FLAGS} -Werror -Wno-deprecated -pipe -ftrapv -fno-omit-frame-pointer")

		if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
			set (SANITIZE_OPTIONS "-fsanitize=integer -fsanitize=undefined-trap -fsanitize=unsigned-integer-overflow")
			set (COMMON_COMPILE_FLAGS "${COMMON_COMPILE_FLAGS} ${SANITIZE_OPTIONS} -fsanitize-blacklist=${CMAKE_SOURCE_DIR}/sanitize-blacklist.txt")
			set (LINK_FLAGS "${LINK_FLAGS} ${SANITIZE_OPTIONS}")
			# Clang is links its sanitizer libraries only to executables,
			# even though they are actually needed all over the code. :-(
			set (ALLOW_UNDEFINED ON)
		endif ()

		if (CMAKE_SYSTEM_NAME MATCHES "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "GNU")
			# -z now checks there are no unresolved symbols at executalbe/library load time, instead of that specific symbol load time
			set (LINK_FLAGS "${LINK_FLAGS} -Wl,-z,now -Wl,--as-needed")
		endif ()
	endif ()

	if (NOT ALLOW_UNDEFINED AND (CMAKE_SYSTEM_NAME MATCHES "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "GNU"))
		set (LINK_FLAGS "${LINK_FLAGS} -Wl,--no-undefined")
	endif ()
endif ()

# Look above, DEBUG_ENABLED is always enabled in Debug configuration.
# Enable it in all configurations when ENABLE_DEVELOPER_BUILD is on.
if (ENABLE_DEVELOPER_BUILD)
	list (APPEND DEFINITIONS DEBUG_ENABLED)
endif ()

# The same notes as DEBUG_ENABLED concern also DEBUG_OUTPUT_ENABLED.
# Additionally, Windows needs DEBUG_OUTPUT_ENABLED because we always
# install kadu_c.exe with console output.
if (ENABLE_DEVELOPER_BUILD OR WIN32)
	list (APPEND DEFINITIONS DEBUG_OUTPUT_ENABLED)
endif ()

# Version information

file (STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/VERSION" KADU_VERSION LIMIT_COUNT 1)

find_package (Git QUIET)
if (GIT_FOUND)
	execute_process (COMMAND "${GIT_EXECUTABLE}" describe --tags --exact-match HEAD
		WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
		RESULT_VARIABLE result
		OUTPUT_VARIABLE git_tag
		ERROR_QUIET
		OUTPUT_STRIP_TRAILING_WHITESPACE
	)

	if (NOT (result STREQUAL 0) OR NOT (git_tag STREQUAL KADU_VERSION))
		execute_process (COMMAND "${GIT_EXECUTABLE}" rev-parse --short --verify HEAD
			WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
			RESULT_VARIABLE result
			OUTPUT_VARIABLE git_commit
			ERROR_QUIET
			OUTPUT_STRIP_TRAILING_WHITESPACE
		)

		if (result STREQUAL 0)
			set (KADU_VERSION "${KADU_VERSION}-g${git_commit}")
		endif ()
	endif ()
endif ()

string (REGEX REPLACE "-.*" "" simple_version ${KADU_VERSION})

if (NOT KADU_VERSION STREQUAL simple_version)
	set (KADU_PRERELEASE TRUE)
endif ()

# Installation paths.

set (INSTALL_SDK_DIR "" CACHE PATH "SDK installation root")
mark_as_advanced (INSTALL_SDK_DIR)
if (NOT INSTALL_SDK_DIR)
	set (INSTALL_SDK_DIR "${CMAKE_INSTALL_PREFIX}/sdk")
	set (install_sdk_dir_set_to_default TRUE)
endif ()

include (GNUInstallDirs)

set (INSTALL_BIN_DIR "${CMAKE_INSTALL_FULL_BINDIR}")
set (INSTALL_LIB_DIR "${CMAKE_INSTALL_FULL_LIBDIR}")
set (INSTALL_DATA_DIR "${CMAKE_INSTALL_FULL_DATADIR}/kadu")
set (INSTALL_PLUGINS_DATA_DIR "${INSTALL_DATA_DIR}/plugins")
set (INSTALL_PLUGINS_LIB_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/kadu/plugins")
set (INSTALL_INCLUDE_DIR "${CMAKE_INSTALL_FULL_INCLUDEDIR}/kadu")
set (INSTALL_CMAKE_DIR "${CMAKE_INSTALL_FULL_DATADIR}/cmake/Kadu")

if (install_sdk_dir_set_to_default)
	set (INSTALL_SDK_DIR "${INSTALL_DATA_DIR}/sdk")
endif ()

if (WIN32)
	set (KADU_DATADIR_RELATIVE_TO_BIN "./")
	set (KADU_PLUGINS_LIBDIR_RELATIVE_TO_BIN "./plugins/")
else ()
	file (RELATIVE_PATH KADU_DATADIR_RELATIVE_TO_BIN "${INSTALL_BIN_DIR}" "${INSTALL_DATA_DIR}")
	file (RELATIVE_PATH KADU_PLUGINS_LIBDIR_RELATIVE_TO_BIN "${INSTALL_BIN_DIR}" "${INSTALL_PLUGINS_LIB_DIR}")
endif ()

if (UNIX AND NOT APPLE)
	set (DESKTOP_FILE_DIR "${CMAKE_INSTALL_FULL_DATADIR}/applications")
	set (DESKTOP_FILE_NAME kadu.desktop)

	file (RELATIVE_PATH KADU_DESKTOP_FILE_DIR_RELATIVE_TO_BIN "${INSTALL_BIN_DIR}" "${DESKTOP_FILE_DIR}")
endif ()

set (install_vars
	INSTALL_SDK_DIR INSTALL_BIN_DIR INSTALL_LIB_DIR INSTALL_DATA_DIR INSTALL_PLUGINS_DATA_DIR
	INSTALL_PLUGINS_LIB_DIR INSTALL_INCLUDE_DIR INSTALL_CMAKE_DIR
)
foreach (install_var ${install_vars})
	if (NOT DEFINED ${install_var})
		message (FATAL_ERROR "Variable ${install_var} does not exist")
	else ()
		if (IS_ABSOLUTE "${${install_var}}")
			file (TO_CMAKE_PATH "${CMAKE_INSTALL_PREFIX}" sane_install_prefix)
			file (TO_CMAKE_PATH "${${install_var}}" sane_install_path)
			if (sane_install_path STREQUAL sane_install_prefix)
				set (RELATIVE_${install_var} "")
			else ()
				string (REPLACE "${sane_install_prefix}/" "" RELATIVE_${install_var} "${sane_install_path}")
			endif ()
			if (RELATIVE_${install_var} STREQUAL "")
				set (RELATIVE_${install_var} ".")
			endif ()

			if (IS_ABSOLUTE "${RELATIVE_${install_var}}")
				message (FATAL_ERROR "${install_var} (${${install_var}}) is not under install prefix.")
			endif ()
		else ()
			set (RELATIVE_${install_var} "${${install_var}}")
		endif()
	endif ()
endforeach ()

set (INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
set (path_vars INSTALL_PREFIX)
if (UNIX AND NOT APPLE)
	list (APPEND path_vars DESKTOP_FILE_DIR)
endif ()

# Generate CMake configuration files

include (CMakePackageConfigHelpers)

macro (kadu_configure_package_config_file _in _out _mode)
	if ("${_mode}" STREQUAL BUILD_TREE)
		foreach (path_var ${path_vars})
			set (PACKAGE_${path_var} "${${path_var}}")
		endforeach ()

		set (PACKAGE_INCLUDE_DIR "${CMAKE_SOURCE_DIR}")
		set (PACKAGE_SDK_DIR "${CMAKE_SOURCE_DIR}")

		configure_package_config_file ("${_in}" "${_out}"
			INSTALL_DESTINATION "${INSTALL_CMAKE_DIR}"
			NO_SET_AND_CHECK_MACRO NO_CHECK_REQUIRED_COMPONENTS_MACRO
		)
	elseif ("${_mode}" STREQUAL INSTALL_TREE)
		set (INCLUDE_DIR "${INSTALL_INCLUDE_DIR}")
		set (SDK_DIR "${INSTALL_SDK_DIR}")
		list (APPEND path_vars INCLUDE_DIR SDK_DIR)

		configure_package_config_file ("${_in}" "${_out}"
			INSTALL_DESTINATION "${INSTALL_CMAKE_DIR}"
			PATH_VARS ${path_vars}
			NO_SET_AND_CHECK_MACRO NO_CHECK_REQUIRED_COMPONENTS_MACRO
		)
	endif ()
endmacro ()

# This one is only for usable within the build tree. We want to actually
# set some variables in there from within the subdirectories, so we generated
# the intallation version later.
kadu_configure_package_config_file (cmake/KaduConfig.cmake.in
	"${CMAKE_BINARY_DIR}/KaduConfig.cmake" BUILD_TREE)

write_basic_package_version_file ("${CMAKE_BINARY_DIR}/KaduConfigVersion.cmake"
	VERSION ${simple_version} COMPATIBILITY AnyNewerVersion
)

# Include the generated file

set (Kadu_DIR "${CMAKE_BINARY_DIR}")
find_package (Kadu REQUIRED CONFIG)

if (NOT WIN32)
	include (CheckIncludeFiles)

	# TODO: Add libexecinfo support
	check_include_files ("execinfo.h" HAVE_EXECINFO)
	if (HAVE_EXECINFO)
		include (CheckFunctionExists)

		check_function_exists ("backtrace" HAVE_EXECINFO)
	endif ()
endif ()

include_directories (${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/kadu-core ${QT_INCLUDES})

add_subdirectory (kadu-core)
add_subdirectory (varia)
add_subdirectory (translations)

include (Plugins.cmake)
add_subdirectory (plugins)

if (BUILD_TESTING)
	enable_testing ()
	add_subdirectory (tests)
endif ()

add_subdirectory (kthxbye)

# Now write KaduConfig for installation.
if (UNIX)
	kadu_configure_package_config_file (cmake/KaduConfig.cmake.in
		"${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/KaduConfig.cmake" INSTALL_TREE)
endif ()

if (KADU_INSTALL_SDK)
	install (FILES
		"${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/KaduConfig.cmake"
		"${CMAKE_BINARY_DIR}/KaduConfigVersion.cmake"
		cmake/KaduMacros.cmake
		DESTINATION "${KADU_INSTALL_CMAKE_DIR}"
	)

	install (EXPORT KaduTargets DESTINATION "${KADU_INSTALL_CMAKE_DIR}")
endif ()

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake IMMEDIATE @ONLY)
add_custom_target (uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

configure_file (varia/scripts/nsis_installer.nsi.in "${CMAKE_CURRENT_BINARY_DIR}/nsis_installer.nsi" ESCAPE_QUOTES @ONLY)

message (STATUS "Kadu (version: ${KADU_VERSION}) will be built:")
message (STATUS " * install prefix: ${CMAKE_INSTALL_PREFIX}")
if (NOT DEFINED CMAKE_CONFIGURATION_TYPES)
	message (STATUS " * build type: ${CMAKE_BUILD_TYPE}")
endif ()

install (FILES AUTHORS AUTHORS.html HISTORY README THANKS ChangeLog ChangeLog.OLD-PL DESTINATION "${KADU_INSTALL_DATA_DIR}")
# For Win32 we use GPL3, and this COPYING is GPL2
if (WIN32)
	install (FILES COPYING.WIN32 DESTINATION "${KADU_INSTALL_DATA_DIR}")
else ()
	install (FILES COPYING DESTINATION "${KADU_INSTALL_DATA_DIR}")
endif ()

=== kadu-core/CMakeLists.txt ===
if (ENABLE_DEVELOPER_BUILD AND NOT MSVC AND NOT APPLE)
	set (FAST_LINKING_DEFAULT ON)
else ()
	set (FAST_LINKING_DEFAULT OFF)
endif ()
option (FAST_LINKING "Enable for linking optimized for low RAM (works best with GCC and GNU ld)" "${FAST_LINKING_DEFAULT}")

if (FAST_LINKING)
	message (STATUS "Fast (re)linking enabled")
else ()
	message (STATUS "Fast (re)linking disabled")
endif ()

if (UNIX AND NOT APPLE)
	if (NOT DEFINED WITH_LIBINDICATE_QT OR WITH_LIBINDICATE_QT)
		find_package (PkgConfig)
		pkg_search_module (LIBINDICATE_QT indicate-qt)
	endif ()

	option (WITH_LIBINDICATE_QT "Compile with Messaging Menu (Ayatana) support through libindicate-qt" "${LIBINDICATE_QT_FOUND}")
	set (KADU_WITH_LIBINDICATE_QT ${WITH_LIBINDICATE_QT} PARENT_SCOPE)  # Do not use it here, it's in parent scope

	if (WITH_LIBINDICATE_QT)
		if (NOT LIBINDICATE_QT_FOUND)
			message (SEND_ERROR "Could NOT find libindicate-qt")
		else ()
			message (STATUS "Found libindicate-qt. Enabling Ayatana support")
			# We need to link core to libindicate-qt so that indicator_docking
			# doesn't crash at unloading. And it crashes mainly because dbus-glib
			# doesn't support being dlclose()'d, so there is no better workaround.
			link_directories (${LIBINDICATE_QT_LIBRARY_DIRS})
			add_definitions (${LIBINDICATE_QT_CFLAGS_OTHER})
			include_directories (${LIBINDICATE_QT_INCLUDE_DIRS})
			list (APPEND ADDITIONAL_LIBRARIES ${LIBINDICATE_QT_LIBRARIES})
		endif ()
	else ()
		message (STATUS "Could NOT find libindicate-qt. Disabling Ayatana support")
	endif ()
endif ()

if (NOT DEFINED NETWORK_IMPLEMENTATION OR "${NETWORK_IMPLEMENTATION}" STREQUAL "ntrack")
	find_package (QNtrack 010)
endif ()

if (NOT DEFINED NETWORK_IMPLEMENTATION)
	if (QNTRACK_FOUND)
		message (STATUS "No NETWORK_IMPLEMENTATION defined. Autodetected implementation: ntrack")
		set (NETWORK_IMPLEMENTATION "ntrack")
	else ()
		message (STATUS "No NETWORK_IMPLEMENTATION defined. Autodetected implementation: Qt")
		set (NETWORK_IMPLEMENTATION "Qt")
	endif ()
endif ()

set (NETWORK_IMPLEMENTATION "${NETWORK_IMPLEMENTATION}" CACHE STRING "Select network-aware implementation (Qt/ntrack/dummy)" FORCE)

if ("${NETWORK_IMPLEMENTATION}" STREQUAL "ntrack")
	list (APPEND ADDITIONAL_LIBRARIES ${QNTRACK_LIBRARIES})
endif ()
# The rest of NETWORK_IMPLEMENTATION stuff is handled in network/CMakeLists.txt.

configure_file (kadu-config.h.in "${CMAKE_CURRENT_BINARY_DIR}/kadu-config.h" ESCAPE_QUOTES)
include_directories ("${CMAKE_CURRENT_BINARY_DIR}")

set (kadu_SRCS
	activate.cpp
	debug.cpp
	kadu-application.cpp
	languages-manager.cpp
	themes.cpp
	updates.cpp

	os/qtsingleapplication/qtlocalpeer.cpp
	os/qtsingleapplication/qtlockedfile.cpp
)

if (WIN32)
	list (APPEND kadu_SRCS
		os/qtsingleapplication/qtlockedfile_win.cpp
		kadu.rc
	)
else ()
	list (APPEND kadu_SRCS
		os/qtsingleapplication/qtlockedfile_unix.cpp
	)
endif ()

if (UNIX AND NOT APPLE)
	list (APPEND kadu_SRCS
		os/x11tools.cpp
	)
endif ()

set (main_SRCS
	main.cpp
)

if (WIN32)
	list (APPEND main_SRCS
		main_win32.cpp
		kadu.rc
	)
else ()
	list (APPEND main_SRCS
		main_unix.cpp
	)
endif ()

set (kadu_MOC_SRCS
	kadu-application.h
	themes.h
	updates.h

	os/qtsingleapplication/qtlocalpeer.h
)

set (kadu_SUBDIRS
	accounts
	avatars
	buddies
	chat
	chat-style
	compression
	configuration
	contacts
	core
	dom
	file-transfer
	formatted-string
	gui
	icons
	identities
	message
	misc
	model
	multilogon
	network
	notify
	os
	parser
	plugin
	protocols
	qt
	services
	status
	storage
	talkable
	themes
	url-handlers
)

find_package (QCA2 REQUIRED)
include_directories (${QCA2_INCLUDE_DIR})
add_definitions (${QCA2_DEFINITIONS})
list (APPEND ADDITIONAL_LIBRARIES ${QCA2_LIBRARIES})

find_package (LibArchive 2.6.0 REQUIRED)
include (CheckLibraryExists)
check_library_exists ("${LibArchive_LIBRARIES}" "archive_write_set_compression_lzma" "" have_libarchive_lzma_support)
check_library_exists ("${LibArchive_LIBRARIES}" "archive_write_set_compression_xz" "" have_libarchive_xz_support)
if (NOT have_libarchive_lzma_support OR NOT have_libarchive_xz_support)
	message (SEND_ERROR "Your libarchive does not have support for lzma and/or xz archives.")
endif ()

include_directories (${LibArchive_INCLUDE_DIRS})
list (APPEND ADDITIONAL_LIBRARIES ${LibArchive_LIBRARIES})

if (UNIX AND NOT APPLE)
	find_package (X11 REQUIRED COMPONENTS X11 Xutil Xfixes)
	if (X11_FOUND AND X11_Xutil_FOUND AND X11_Xfixes_FOUND)
		message (STATUS "Found required X11 libraries: ${X11_X11_LIB};${X11_Xfixes_LIB}")
	else ()
		message (FATAL_ERROR "Could NOT find X11 or X11 Xfixes extension")
	endif ()

	include_directories (${X11_INCLUDE_DIR})
	list (APPEND ADDITIONAL_LIBRARIES ${X11_X11_LIB} ${X11_Xfixes_LIB})
endif ()

if (APPLE)
	list (APPEND ADDITIONAL_LIBRARIES "-framework carbon")
endif ()

macro (kadu_subdirectory SUBDIR SRCS MOC_SRCS ADDITIONAL_INCLUDES)
	if (FAST_LINKING)
		add_library (${SUBDIR}
			STATIC
			${SRCS}
			${MOC_SRCS}
		)
		kadu_set_flags (${SUBDIR})
		set_property (TARGET ${SUBDIR} PROPERTY POSITION_INDEPENDENT_CODE TRUE)
		set_property (TARGET ${SUBDIR} APPEND PROPERTY COMPILE_DEFINITIONS libkadu_EXPORTS)
	else ()
		set (tmp "")
		foreach (SRC ${SRCS})
			list (APPEND tmp "${SUBDIR}/${SRC}")
		endforeach ()

		set (tmp_moc "")
		foreach (MOC_SRC ${MOC_SRCS})
			list (APPEND tmp_moc "${SUBDIR}/${MOC_SRC}")
		endforeach ()

		set (${SUBDIR}_SRCS "${tmp}" PARENT_SCOPE)
		set (${SUBDIR}_MOC_SRCS "${tmp_moc}" PARENT_SCOPE)
		set (${SUBDIR}_INCLUDES "${ADDITIONAL_INCLUDES}" PARENT_SCOPE)
	endif ()
endmacro ()

foreach (ARG ${kadu_SUBDIRS})
	add_subdirectory (${ARG})

	if (NOT FAST_LINKING)
		list (APPEND kadu_SUBDIRS_SRCS ${${ARG}_SRCS} ${${ARG}_MOC_SRCS})
		include_directories (${${ARG}_INCLUDES})
	endif ()
endforeach ()

add_library (libkadu SHARED ${kadu_SRCS} ${kadu_MOC_SRCS} ${kadu_SUBDIRS_SRCS})
kadu_set_flags (libkadu)
set_property (TARGET libkadu PROPERTY PREFIX "")

if (FAST_LINKING)
	if (APPLE)
		target_link_libraries (libkadu LINK_PRIVATE -Wl,-all_load ${kadu_SUBDIRS})
	else ()
		target_link_libraries (libkadu LINK_PRIVATE -Wl,--start-group -Wl,--whole-archive ${kadu_SUBDIRS} -Wl,--no-whole-archive -Wl,--end-group)
	endif ()
endif ()

target_link_libraries (libkadu LINK_PRIVATE ${QT_LIBRARIES} ${ADDITIONAL_LIBRARIES})

add_executable (kadu WIN32 ${main_SRCS})
kadu_set_flags (kadu)
target_link_libraries (kadu LINK_PRIVATE libkadu ${QT_LIBRARIES} ${QT_QTMAIN_LIBRARY})
if (NOT IS_ABSOLUTE "${KADU_INSTALL_LIB_DIR}")
	set (install_full_lib_dir "${CMAKE_INSTALL_PREFIX}/${KADU_INSTALL_LIB_DIR}")
else ()
	set (install_full_lib_dir "${KADU_INSTALL_LIB_DIR}")
endif ()
set_target_properties (kadu PROPERTIES
	INSTALL_RPATH "${install_full_lib_dir}/kadu"
	BUILD_WITH_INSTALL_RPATH TRUE
)

install (TARGETS libkadu kadu
	EXPORT KaduTargets
	LIBRARY DESTINATION ${KADU_INSTALL_LIB_DIR}/kadu
	RUNTIME DESTINATION ${KADU_INSTALL_BIN_DIR}
)
# TODO this WIN32 check is a workaround for an error on Linux
if (WIN32 AND KADU_INSTALL_SDK)
	install (TARGETS libkadu ARCHIVE DESTINATION ${KADU_INSTALL_SDK_DIR}/lib)
endif ()

if (WIN32)
	add_executable (kadu_c ${main_SRCS})
	kadu_set_flags (kadu_c)

	set_property (TARGET kadu_c APPEND PROPERTY COMPILE_DEFINITIONS KADU_CONSOLE)

	target_link_libraries (kadu LINK_PRIVATE ws2_32)
	target_link_libraries (kadu_c LINK_PRIVATE libkadu ${QT_LIBRARIES} ws2_32)

	install (TARGETS kadu_c DESTINATION ${KADU_INSTALL_BIN_DIR})

	file (WRITE "${CMAKE_CURRENT_BINARY_DIR}/qt.conf" "[Paths]\nPlugins = qt-plugins\nTranslations = translations\n")
	install (FILES "${CMAKE_CURRENT_BINARY_DIR}/qt.conf" "kadu.ico" DESTINATION "${KADU_INSTALL_BIN_DIR}")
endif ()

install (TARGETS kadu DESTINATION ${KADU_INSTALL_BIN_DIR})

if (UNIX AND NOT APPLE)
	configure_file (kadu.desktop.in "${CMAKE_CURRENT_BINARY_DIR}/${KADU_DESKTOP_FILE_NAME}")
	install (FILES "${CMAKE_CURRENT_BINARY_DIR}/${KADU_DESKTOP_FILE_NAME}" DESTINATION "${KADU_DESKTOP_FILE_DIR}")

	install (FILES hi16-app-kadu.png DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/16x16/apps" RENAME kadu.png)
	install (FILES hi22-app-kadu.png DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/22x22/apps" RENAME kadu.png)
	install (FILES hi24-app-kadu.png DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/24x24/apps" RENAME kadu.png)
	install (FILES hi32-app-kadu.png DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/apps" RENAME kadu.png)
	install (FILES hi48-app-kadu.png DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/48x48/apps" RENAME kadu.png)
	install (FILES hi64-app-kadu.png DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/64x64/apps" RENAME kadu.png)
	install (FILES hi128-app-kadu.png DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/128x128/apps" RENAME kadu.png)
	install (FILES hi256-app-kadu.png DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/256x256/apps" RENAME kadu.png)
endif ()

install (FILES "chat-style/engine/chat-scripts.js" DESTINATION "${KADU_INSTALL_DATA_DIR}/scripts")

# install api headers
# how to get list: find . -name '*.h' -exec dirname {} +|sort|uniq|sed -e 's|\./||' -e 's|^|\t|'
# TODO: consider using file (GLOB_RECURSE) command here
kadu_api_directories (kadu-core
	.
	accounts
	accounts/filter
	accounts/model
	avatars
	buddies
	buddies/model
	chat
	chat/model
	chat/style-engine
	chat-style/engine/chat-engine-adium
	chat-style/engine/chat-engine-kadu
	chat/type
	compression
	configuration
	contacts
	contacts/model
	core
	dom
	file-transfer
	formatted-string
	gui
	gui/actions
	gui/actions/chat
	gui/menu
	gui/model
	gui/services
	gui/widgets
	gui/widgets/configuration
	gui/widgets/dialog
	gui/widgets/chat-widget
	gui/widgets/webkit-messages-view
	chat-style/engine
	gui/windows
	gui/windows/open-chat-with
	icons
	identities
	identities/model
	message
	misc
	model
	multilogon
	multilogon/model
	network
	network/proxy
	network/proxy/model
	notify
	notify/listener
	notify/notification
	os
	os/generic
	os/qtsingleapplication
	parser
	plugin
	plugin/model
	protocols
	protocols/filter
	protocols/model
	protocols/services
	protocols/services/roster
	provider
	qt
	services
	status
	storage
	talkable
	talkable/filter
	talkable/model
	themes
	url-handlers
)

=== kadu-core/chat/CMakeLists.txt ===
set (chat_SRCS
	buddy-chat-manager.cpp
	chat.cpp
	chat-details-buddy.cpp
	chat-details-contact.cpp
	chat-details-contact-set.cpp
	chat-details-room.cpp
	chat-list-mime-data-helper.cpp
	chat-manager.cpp
	chat-shared.cpp
	recent-chat-manager.cpp

	model/chat-data-extractor.cpp
	model/chat-list-model.cpp
	model/chat-manager-adapter.cpp

	type/chat-type.cpp
	type/chat-type-aware-object.cpp
	type/chat-type-buddy.cpp
	type/chat-type-contact.cpp
	type/chat-type-contact-set.cpp
	type/chat-type-manager.cpp
	type/chat-type-room.cpp
)

set (chat_MOC_SRCS
	buddy-chat-manager.h
	chat-details.h
	chat-details-buddy.h
	chat-details-contact.h
	chat-details-contact-set.h
	chat-details-room.h
	chat-manager.h
	chat-shared.h
	recent-chat-manager.h

	model/chat-list-model.h
	model/chat-manager-adapter.h

	type/chat-type.h
	type/chat-type-buddy.h
	type/chat-type-contact.h
	type/chat-type-contact-set.h
	type/chat-type-manager.h
	type/chat-type-room.h
)

kadu_subdirectory (chat "${chat_SRCS}" "${chat_MOC_SRCS}" "")

=== kadu-core/configuration/CMakeLists.txt ===
set (configuration_SRCS
	chat-configuration-holder.cpp
	config-file-data-manager.cpp
	config-file-variant-wrapper.cpp
	configuration-aware-object.cpp
	configuration-file.cpp
	configuration-holder.cpp
	configuration-manager.cpp
	main-configuration-holder.cpp
	notifier-configuration-data-manager.cpp
	toolbar-configuration-manager.cpp
	xml-configuration-file.cpp
)

set (configuration_MOC_SRCS
	chat-configuration-holder.h
	config-file-data-manager.h
	configuration-holder.h
	configuration-window-data-manager.h
	configuration-manager.h
	main-configuration-holder.h
	notifier-configuration-data-manager.h
	toolbar-configuration-manager.h
)

kadu_subdirectory (configuration "${configuration_SRCS}" "${configuration_MOC_SRCS}" "")

=== kadu-core/gui/CMakeLists.txt ===
set (gui_SRCS
	actions/chat/add-conference-action.cpp
	actions/chat/add-room-chat-action.cpp
	actions/chat/leave-chat-action.cpp

	actions/action.cpp
	actions/actions.cpp
	actions/action-description.cpp
	actions/base-action-context.cpp
	actions/change-status-action.cpp
	actions/default-proxy-action.cpp
	actions/delete-talkable-action.cpp
	actions/edit-talkable-action.cpp
	actions/recent-chats-action.cpp

	menu/kadu-menu.cpp
	menu/menu-inventory.cpp
	menu/menu-item.cpp

	model/checkbox-styled-item-delegate.cpp

	services/clipboard-html-transformer-service.cpp

	widgets/chat-widget/chat-widget.cpp
	widgets/chat-widget/chat-widget-actions.cpp
	widgets/chat-widget/chat-widget-activation-service.cpp
	widgets/chat-widget/chat-widget-container-handler.cpp
	widgets/chat-widget/chat-widget-container-handler-mapper.cpp
	widgets/chat-widget/chat-widget-container-handler-repository.cpp
	widgets/chat-widget/chat-widget-factory.cpp
	widgets/chat-widget/chat-widget-manager.cpp
	widgets/chat-widget/chat-widget-message-handler.cpp
	widgets/chat-widget/chat-widget-message-handler-configuration.cpp
	widgets/chat-widget/chat-widget-message-handler-configurator.cpp
	widgets/chat-widget/chat-widget-repository.cpp

	widgets/group-tab-bar/group-filter-tab-data.cpp
	widgets/group-tab-bar/group-tab-bar.cpp
	widgets/group-tab-bar/group-tab-bar-configuration.cpp
	widgets/group-tab-bar/group-tab-bar-configurator.cpp

	widgets/account-add-widget.cpp
	widgets/account-avatar-widget.cpp
	widgets/account-buddy-list-widget.cpp
	widgets/account-configuration-widget.cpp
	widgets/account-configuration-widget-factory-repository.cpp
	widgets/account-configuration-widget-tab-adapter.cpp
	widgets/account-create-widget.cpp
	widgets/account-edit-widget.cpp
	widgets/accounts-combo-box.cpp
	widgets/actions-combo-box.cpp
	widgets/avatar-painter.cpp
	widgets/buddy-avatar-widget.cpp
	widgets/buddy-configuration-widget.cpp
	widgets/buddy-configuration-widget-factory-repository.cpp
	widgets/buddy-configuration-widget-tab-adapter.cpp
	widgets/buddy-contacts-table-delegate.cpp
	widgets/buddy-contacts-table-item.cpp
	widgets/buddy-contacts-table-model.cpp
	widgets/buddy-contacts-table-model-proxy.cpp
	widgets/buddy-contacts-table.cpp
	widgets/buddy-general-configuration-widget.cpp
	widgets/buddy-groups-configuration-widget.cpp
	widgets/buddy-personal-info-configuration-widget.cpp
	widgets/buddy-options-configuration-widget.cpp
	widgets/buddy-info-panel.cpp
	widgets/categorized-list-view.cpp
	widgets/categorized-list-view-painter.cpp
	widgets/chat-configuration-widget.cpp
	widgets/chat-configuration-widget-factory-repository.cpp
	widgets/chat-configuration-widget-tab-adapter.cpp
	widgets/chat-edit-box.cpp
	widgets/chat-edit-box-size-manager.cpp
	widgets/chat-edit-widget.cpp
	widgets/chat-room-edit-widget.cpp
	widgets/chat-style-preview.cpp
	widgets/chat-top-bar-container-widget.cpp
	widgets/chat-top-bar-widget-factory-repository.cpp
	widgets/chat-view-network-access-manager.cpp
	widgets/choose-identity-widget.cpp
	widgets/color-button.cpp
	widgets/color-selector.cpp
	widgets/composite-configuration-value-state-notifier.cpp
	widgets/configuration-value-state-notifier.cpp
	widgets/custom-input.cpp
	widgets/custom-input-menu-item.cpp
	widgets/custom-input-menu-manager.cpp
	widgets/delayed-line-edit.cpp
	widgets/file-transfer-widget.cpp
	widgets/filter-widget.cpp
	widgets/filtered-tree-view.cpp
	widgets/group-list.cpp
	widgets/groups-combo-box.cpp
	widgets/identities-combo-box.cpp
	widgets/kadu-text-edit.cpp
	widgets/kadu-tree-view.cpp
	widgets/kadu-tree-view-delegate.cpp
	widgets/kadu-web-view.cpp
	widgets/line-edit-clear-button.cpp
	widgets/line-edit-with-clear-button.cpp
	widgets/modal-configuration-widget.cpp
	widgets/path-edit.cpp
	widgets/path-list-edit.cpp
	widgets/protocols-combo-box.cpp
	widgets/proxy-combo-box.cpp
	widgets/preview.cpp
	widgets/recent-chats-menu.cpp
	widgets/roster-widget.cpp
	widgets/search-bar.cpp
	widgets/select-file.cpp
	widgets/select-font.cpp
	widgets/select-talkable-combo-box.cpp
	widgets/select-talkable-popup.cpp
	widgets/simple-configuration-value-state-notifier.cpp
	widgets/status-button.cpp
	widgets/status-buttons.cpp
	widgets/status-menu.cpp
	widgets/syntax-editor.cpp
	widgets/talkable-delegate.cpp
	widgets/talkable-delegate-configuration.cpp
	widgets/talkable-painter.cpp
	widgets/talkable-tree-view.cpp
	widgets/toolbar.cpp
	widgets/tool-tip-class-manager.cpp
	widgets/wait-overlay.cpp
	widgets/webkit-messages-view/message-limiter.cpp
	widgets/webkit-messages-view/webkit-messages-view.cpp
	widgets/webkit-messages-view/webkit-messages-view-clearing-display.cpp
	widgets/webkit-messages-view/webkit-messages-view-display.cpp
	widgets/webkit-messages-view/webkit-messages-view-display-factory.cpp
	widgets/webkit-messages-view/webkit-messages-view-factory.cpp
	widgets/webkit-messages-view/webkit-messages-view-handler.cpp
	widgets/webkit-messages-view/webkit-messages-view-handler-factory.cpp
	widgets/webkit-messages-view/webkit-messages-view-removing-display.cpp

	widgets/configuration/buddy-list-background-colors-widget.cpp
	widgets/configuration/config-action-button.cpp
	widgets/configuration/config-check-box.cpp
	widgets/configuration/config-color-button.cpp
	widgets/configuration/config-combo-box.cpp
	widgets/configuration/config-gg-password-edit.cpp
	widgets/configuration/config-hot-key-edit.cpp
	widgets/configuration/config-label.cpp
	widgets/configuration/config-line-separator.cpp
	widgets/configuration/config-line-edit.cpp
	widgets/configuration/config-list-widget.cpp
	widgets/configuration/config-path-list-edit.cpp
	widgets/configuration/config-preview.cpp
	widgets/configuration/config-proxy-combo-box.cpp
	widgets/configuration/config-radio-button.cpp
	widgets/configuration/config-select-file.cpp
	widgets/configuration/config-select-font.cpp
	widgets/configuration/config-slider.cpp
	widgets/configuration/config-spin-box.cpp
	widgets/configuration/config-syntax-editor.cpp
	widgets/configuration/config-widget-value.cpp
	widgets/configuration/config-widget.cpp
	widgets/configuration/configuration-widget.cpp
	widgets/configuration/config-section.cpp
	widgets/configuration/config-group-box.cpp
	widgets/configuration/config-tab.cpp
	widgets/configuration/notifier-configuration-widget.cpp
	widgets/configuration/notify-group-box.cpp
	widgets/configuration/notify-tree-widget.cpp

	widgets/dialog/add-group-dialog-widget.cpp
	widgets/dialog/edit-group-dialog-widget.cpp
	widgets/dialog/merge-buddies-dialog-widget.cpp
	widgets/dialog/password-dialog-widget.cpp
	widgets/dialog/title-widget.cpp

	windows/chat-window/chat-window.cpp
	windows/chat-window/chat-window-factory.cpp
	windows/chat-window/chat-window-manager.cpp
	windows/chat-window/chat-window-repository.cpp
	windows/chat-window/chat-window-storage.cpp
	windows/chat-window/chat-window-storage-configuration.cpp
	windows/chat-window/chat-window-storage-configurator.cpp
	windows/chat-window/window-chat-widget-container-handler.cpp

	windows/about.cpp
	windows/add-buddy-window.cpp
	windows/add-conference-window.cpp
	windows/add-room-chat-window.cpp
	windows/buddy-data-window.cpp
	windows/buddy-data-window-repository.cpp
	windows/buddy-delete-window.cpp
	windows/chat-data-window.cpp
	windows/chat-data-window-repository.cpp
	windows/configuration-window.cpp
	windows/file-transfer-window.cpp
	windows/group-properties-window.cpp
	windows/kadu-dialog.cpp
	windows/kadu-window.cpp
	windows/kadu-window-actions.cpp
	windows/main-configuration-window.cpp
	windows/main-window.cpp
	windows/message-dialog.cpp
	windows/multilogon-window.cpp
	windows/progress-window.cpp
	windows/proxy-action-context.cpp
	windows/proxy-edit-window.cpp
	windows/search-window.cpp
	windows/search-window-actions.cpp
	windows/status-window.cpp
	windows/status-window-description-proxy-model.cpp
	windows/string-list-dialog.cpp
	windows/subscription-window.cpp
	windows/token-window.cpp
	windows/updates-dialog.cpp
	windows/window-notifier-window.cpp
	windows/your-accounts.cpp

	windows/open-chat-with/open-chat-with.cpp
	windows/open-chat-with/open-chat-with-contact-list-runner.cpp
	windows/open-chat-with/open-chat-with-runner-manager.cpp

	hot-key.cpp
	status-icon.cpp
	web-view-highlighter.cpp
	window-manager.cpp
)

set (gui_MOC_SRCS
	actions/chat/add-conference-action.h
	actions/chat/add-room-chat-action.h
	actions/chat/leave-chat-action.h

	actions/action.h
	actions/actions.h
	actions/action-context.h
	actions/action-description.h
	actions/base-action-context.h
	actions/change-status-action.h
	actions/delete-talkable-action.h
	actions/default-proxy-action.h
	actions/edit-talkable-action.h
	actions/recent-chats-action.h

	menu/kadu-menu.h
	menu/menu-inventory.h

	model/checkbox-styled-item-delegate.h

	services/clipboard-html-transformer-service.h

	widgets/account-add-widget.h
	widgets/account-avatar-widget.h
	widgets/account-buddy-list-widget.h
	widgets/account-configuration-widget.h
	widgets/account-configuration-widget-factory-repository.h
	widgets/account-configuration-widget-tab-adapter.h
	widgets/account-create-widget.h
	widgets/account-edit-widget.h
	widgets/accounts-combo-box.h
	widgets/actions-combo-box.h
	widgets/buddy-avatar-widget.h
	widgets/buddy-configuration-widget.h
	widgets/buddy-configuration-widget-factory-repository.h
	widgets/buddy-configuration-widget-tab-adapter.h
	widgets/buddy-contacts-table-delegate.h
	widgets/buddy-contacts-table-item.h
	widgets/buddy-contacts-table-model.h
	widgets/buddy-contacts-table-model-proxy.h
	widgets/buddy-contacts-table.h
	widgets/buddy-general-configuration-widget.h
	widgets/buddy-groups-configuration-widget.h
	widgets/buddy-personal-info-configuration-widget.h
	widgets/buddy-options-configuration-widget.h
	widgets/buddy-info-panel.h
	widgets/categorized-list-view.h
	widgets/categorized-list-view-painter.h
	widgets/chat-configuration-widget.h
	widgets/chat-configuration-widget-factory-repository.h
	widgets/chat-configuration-widget-tab-adapter.h
	widgets/chat-edit-box.h
	widgets/chat-edit-box-size-manager.h
	widgets/chat-edit-widget.h
	widgets/chat-room-edit-widget.h
	widgets/chat-view-network-access-manager.h
	widgets/choose-identity-widget.h
	widgets/color-button.h
	widgets/color-selector.h
	widgets/composite-configuration-value-state-notifier.h
	widgets/configuration-value-state-notifier.h
	widgets/custom-input.h
	widgets/custom-input-menu-manager.h
	widgets/delayed-line-edit.h
	widgets/file-transfer-widget.h
	widgets/filter-widget.h
	widgets/filtered-tree-view.h
	widgets/group-list.h
	widgets/groups-combo-box.h
	widgets/identities-combo-box.h
	widgets/kadu-text-edit.h
	widgets/kadu-tree-view.h
	widgets/kadu-tree-view-delegate.h
	widgets/kadu-web-view.h
	widgets/line-edit-clear-button.h
	widgets/line-edit-with-clear-button.h
	widgets/modal-configuration-widget.h
	widgets/path-edit.h
	widgets/path-list-edit.h
	widgets/preview.h
	widgets/proxy-combo-box.h
	widgets/protocols-combo-box.h
	widgets/recent-chats-menu.h
	widgets/roster-widget.h
	widgets/search-bar.h
	widgets/select-file.h
	widgets/select-font.h
	widgets/select-talkable-combo-box.h
	widgets/select-talkable-popup.h
	widgets/simple-configuration-value-state-notifier.h
	widgets/status-button.h
	widgets/status-buttons.h
	widgets/status-menu.h
	widgets/syntax-editor.h
	widgets/talkable-delegate.h
	widgets/talkable-tree-view.h
	widgets/toolbar.h
	widgets/wait-overlay.h

	widgets/configuration/buddy-list-background-colors-widget.h
	widgets/configuration/config-action-button.h
	widgets/configuration/config-check-box.h
	#widgets/configuration/config-widget-value.h
	widgets/configuration/configuration-widget.h
	widgets/configuration/config-label.h
	widgets/configuration/config-color-button.h
	widgets/configuration/config-combo-box.h
	widgets/configuration/config-gg-password-edit.h
	widgets/configuration/config-group-box.h
	widgets/configuration/config-hot-key-edit.h
	widgets/configuration/config-line-edit.h
	widgets/configuration/config-line-separator.h

=== kadu-core/notify/CMakeLists.txt ===
set (notify_SRCS
	listener/account-event-listener.cpp
	notification/account-notification.cpp
	notification/chat-notification.cpp
	listener/chat-event-listener.cpp
	listener/event-listener.cpp
	listener/group-event-listener.cpp
	notification/aggregate-notification.cpp
	notification/new-message-notification.cpp
	notification/multilogon-notification.cpp
	notification/notification.cpp
	notification-manager.cpp
	notifier.cpp
	notify-configuration-ui-handler.cpp
	notify-event.cpp
	screen-mode-checker.cpp
	notification/status-changed-notification.cpp
	window-notifier.cpp
)

set (notify_MOC_SRCS
	listener/account-event-listener.h
	notification/account-notification.h
	notification/chat-notification.h
	listener/chat-event-listener.h
	listener/event-listener.h
	listener/group-event-listener.h
	notification/aggregate-notification.h
	notification/new-message-notification.h
	notification/multilogon-notification.h
	notification/notification.h
	notification-manager.h
	notifier.h
	notify-configuration-ui-handler.h
	screen-mode-checker.h
	notification/status-changed-notification.h
	window-notifier.h
)

if (WIN32)
    list (APPEND notify_SRCS "windows-screen-mode-checker.cpp")
elseif (UNIX AND NOT APPLE)
    list (APPEND notify_SRCS "x11-screen-mode-checker.cpp")
endif ()

kadu_subdirectory (notify "${notify_SRCS}" "${notify_MOC_SRCS}" "")

=== kadu-core/plugin/CMakeLists.txt ===
set (plugin_SRCS
	activation/active-plugin.cpp
	activation/plugin-activation-error-handler.cpp
	activation/plugin-activation-service.cpp
	activation/plugin-loader.cpp
	activation/plugin-root-component-handler.cpp
	activation/plugin-translations-loader.cpp
	dependency-graph/plugin-dependency-graph.cpp
	dependency-graph/plugin-dependency-graph-builder.cpp
	gui/plugin-error-dialog.cpp
	gui/plugin-list/plugin-list-widget.cpp
	gui/plugin-list/plugin-list-view-delegate.cpp
	gui/plugin-list/plugin-list-view-delegate-widgets.cpp
	gui/plugin-list/plugin-list-widget-item-delegate.cpp
	metadata/plugin-metadata.cpp
	metadata/plugin-metadata-builder.cpp
	metadata/plugin-metadata-finder.cpp
	metadata/plugin-metadata-provider.cpp
	metadata/plugin-metadata-reader.cpp
	model/plugin-model.cpp
	model/plugin-proxy-model.cpp
	state/plugin-state.cpp
	state/plugin-state-manager.cpp
	state/plugin-state-service.cpp
	state/plugin-state-storage.cpp
	state/plugin-state-storage-09.cpp
	plugin-conflict-resolver.cpp
	plugin-dependency-handler.cpp
	plugin-manager.cpp
)

kadu_subdirectory (plugin "${plugin_SRCS}" "" "")

=== kadu-core/protocols/CMakeLists.txt ===
set (protocols_SRCS
	filter/can-register-protocol-filter.cpp

	model/protocols-model.cpp
	model/protocols-model-proxy.cpp

	services/account-service.cpp
	services/avatar-service.cpp
	services/chat-image.cpp
	services/chat-image-service.cpp
	services/chat-service.cpp
	services/chat-state-service.cpp
	services/contact-list-service.cpp

	services/roster/roster-entry.cpp
	services/roster/roster-notifier.cpp
	services/roster/roster-service.cpp
	services/roster/roster-task.cpp

	connection-error-notification.cpp
	protocol.cpp
	protocols-manager.cpp
	protocol-state-machine.cpp
	roster.cpp
)

set (protocols_MOC_SRCS
	filter/abstract-protocol-filter.h
	filter/can-register-protocol-filter.h

	model/protocols-model.h
	model/protocols-model-proxy.h

	services/account-service.h
	services/avatar-downloader.h
	services/avatar-service.h
	services/avatar-uploader.h
	services/chat-image-service.h
	services/chat-service.h
	services/chat-state-service.h
	services/contact-list-service.h
	services/contact-personal-info-service.h
	services/file-transfer-service.h
	services/multilogon-service.h
	services/personal-info-service.h
	services/search-service.h
	services/subscription-service.h

	connection-error-notification.h
	protocol.h
	protocol-factory.h
	protocols-manager.h
	protocol-state-machine.h
	roster.h
)

kadu_subdirectory (protocols "${protocols_SRCS}" "${protocols_MOC_SRCS}" "")

=== plugins/desktop_docking/CMakeLists.txt ===
project (desktop_docking)

cmake_minimum_required (VERSION 2.8)

find_package (Kadu REQUIRED CONFIG)

set (SOURCES
	configuration/gui/desktop-dock-configuration-ui-handler.cpp
	gui/windows/desktop-dock-window.cpp
	desktop-docking-plugin.cpp
	desktop-dock.cpp
)

set (MOC_SOURCES
	configuration/gui/desktop-dock-configuration-ui-handler.h
	gui/windows/desktop-dock-window.h
	desktop-docking-plugin.h
	desktop-dock.h
)

set (CONFIGURATION_FILES
	data/configuration/desktop_docking.ui
)

kadu_plugin (desktop_docking
	PLUGIN_SOURCES ${SOURCES}
	PLUGIN_MOC_SOURCES ${MOC_SOURCES}
	PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
	PLUGIN_DEPENDENCIES docking
)

=== plugins/docking/CMakeLists.txt ===
project (docking)

cmake_minimum_required (VERSION 2.8)

find_package (Kadu REQUIRED CONFIG)

kadu_api_directories (plugins/docking
	.
)

set (SOURCES
	docking-plugin.cpp
	docking.cpp
)

set (MOC_SOURCES
	docking-plugin.h
	docking.h
)

if (APPLE)
	list (APPEND SOURCES mac_docking_helper.cpp)
	list (APPEND MOC_SOURCES mac_docking_helper.h)
	set_source_files_properties (SOURCE mac_docking_helper.cpp APPEND_STRING PROPERTY COMPILE_FLAGS " -x objective-c++")
endif ()

set (CONFIGURATION_FILES
	data/configuration/docking.ui
)

kadu_plugin (docking
	PLUGIN_SOURCES ${SOURCES}
	PLUGIN_MOC_SOURCES ${MOC_SOURCES}
	PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
)

=== plugins/encryption_ng/CMakeLists.txt ===
project (encryption_ng)

cmake_minimum_required (VERSION 2.8)

# Needed for FindQCA2.cmake when building externally
list (INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/../../cmake/Modules")

find_package (Kadu REQUIRED CONFIG)

kadu_api_directories (plugins/encryption_ng
	configuration
	keys
	notify
	.
)

set (SOURCES
	actions/encryption-set-up-action-description.cpp
	actions/generate-keys-action-description.cpp

	gui/encryption-set-up-menu.cpp

	keys/keys-manager.cpp
	keys/key-shared.cpp
	keys/key.cpp

	notify/encryption-ng-notification.cpp

	decryptor.cpp
	decryptor-wrapper.cpp
	encryption-actions.cpp
	encryption-chat-data.cpp
	encryption-manager.cpp
	encryption-ng-plugin.cpp
	encryption-provider-manager.cpp
	encryptor.cpp
)

set (MOC_SOURCES
	actions/encryption-set-up-action-description.h
	actions/generate-keys-action-description.h

	gui/encryption-set-up-menu.h

	keys/keys-manager.h
	keys/key-shared.h

	notify/encryption-ng-notification.h

	decryptor.h
	decryptor-wrapper.h
	encryption-actions.h
	encryption-chat-data.h
	encryption-manager.h
	encryption-ng-plugin.h
	encryption-provider.h
	encryption-provider-manager.h
	encryptor.h
)

set (CONFIGURATION_FILES
)

find_package (QCA2 REQUIRED)

if (APPLE)
	if (QCA_FRAMEWORK_DIR)
		set (QCA2_INCLUDE_DIR ${QCA_FRAMEWORK_DIR}/qca.framework/Headers/)
		set (QCA2_LIBRARIES "-framework qca")
		link_directories (${QCA_FRAMEWORK_DIR}/qca.framework/)
	endif ()
endif ()

add_definitions (${QCA2_DEFINITIONS})
include_directories (${QCA2_INCLUDE_DIR})

kadu_plugin (encryption_ng
	PLUGIN_SOURCES ${SOURCES}
	PLUGIN_MOC_SOURCES ${MOC_SOURCES}
	PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
	PLUGIN_LIBRARIES ${QCA2_LIBRARIES}
)

=== plugins/ext_sound/CMakeLists.txt ===
project (ext_sound)

cmake_minimum_required (VERSION 2.8)

find_package (Kadu REQUIRED CONFIG)

set (SOURCES
	external-player.cpp
	ext-sound-plugin.cpp
)

set (MOC_SOURCES
	external-player.h
	ext-sound-plugin.h
)

set (CONFIGURATION_FILES
	configuration/ext_sound.ui
)

kadu_plugin (ext_sound
	PLUGIN_SOURCES ${SOURCES}
	PLUGIN_MOC_SOURCES ${MOC_SOURCES}
	PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
	PLUGIN_DEPENDENCIES sound
)

=== debian/changelog ===
kadu (1.2-2) unstable; urgency=medium

  * Changed Architecture of kadu-dev to any

 -- Patryk Cisek <patryk@debian.org>  Sun, 23 Nov 2014 16:25:21 +0100

kadu (1.2-1) unstable; urgency=medium

  * New upstream release (Closes: #768463)

 -- Patryk Cisek <patryk@debian.org>  Sat, 08 Nov 2014 15:17:42 +0100

kadu (1.1-1) unstable; urgency=medium

  * New upstream release.
  * Removed 03-no-CMAKE_CXX_FLAGS-overwrite.patch patch. It's been
    included upstream.

 -- Patryk Cisek <patryk@debian.org>  Sun, 19 Oct 2014 10:01:12 +0200

=== debian/control ===
Source: kadu
Section: net
Priority: optional
Maintainer: Patryk Cisek <patryk@debian.org>
Vcs-Git: git://git.debian.org/users/patryk/kadu.git
Vcs-Browser: http://git.debian.org/?p=users/patryk/kadu.git
Build-Depends: bzip2,
               chrpath,
               cmake (>=2.6),
               debhelper (>= 9),
               enchant,
               libarchive-dev,
               libasound2-dev,
               libaudio-dev,
               libdbus-1-dev,
               libenchant-dev,
               libgadu-dev,
               libidn11-dev,
               libindicate-qt-dev,
               libmpdclient-dev,
               libotr5-dev,
               libphonon-dev,
               libqca2-dev,
               libqt4-dev,
               libqtwebkit-dev,
               libsndfile1-dev (>= 1.0),
               libsqlite3-dev,
               libxfixes-dev,
               libxss-dev,
               libxtst-dev,
               patchutils (>= 0.2.25),
               pkgconf,
               sharutils,
               x11proto-scrnsaver-dev,
               zlib1g-dev
Standards-Version: 3.9.6
Homepage: http://kadu.net

Package: kadu
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: kadu-common (= ${source:Version}),
         libkadu (= ${binary:Version}),
         libqca2-plugin-ossl,
         libqt4-sql-sqlite,
         libqt4-svg,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: kadu-external-modules (<< 1.0)
Replaces: kadu-external-modules (<< 1.0)
Suggests: kadu-themes
Description: Gadu-Gadu/XMPP client for X11
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides Kadu along with plugins developed by Kadu developers.

Package: libkadu
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Gadu-Gadu/XMPP client for X11
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package contains libkadu, which is used by Kadu.

Package: kadu-common
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: kadu-external-modules (<< 0.10.0-2)
Suggests: kadu-themes
Description: Gadu-Gadu/XMPP client for X11
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides data common for all architectures.

Package: kadu-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Development files needed to compile plugins for kadu
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides development files needed to compile plugins for Kadu.

Package: kadu-themes
Architecture: all
Depends: ${misc:Depends}
Recommends: kadu
Description: Additional icons and emoticons for Kadu
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides additional icons, sounds and emoticons themes for
 Kadu.
